/* ein einfacher Client fuer einen UDP-basierten Echo-Server 
   (c) 1999 C. Hutter <hutter@uni-trier.de> */

#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <errno.h>

int main(void)
{
  int aSocket;
  int listenPort=5000;
  struct sockaddr_in serverAddr, clientAddr;
  char message[1000]="A line of text\n";
  int messageLen,bytesReceived,bytesSent;

  messageLen=sizeof(message);
 
  /* Socket generieren*/
  aSocket=socket(AF_INET,SOCK_DGRAM,0);
  if (aSocket<0){
    printf("Fehler bei Socketgenerierung\n");
    exit(-1);
  }
  
  /* Struct fuellen */
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(listenPort);
  serverAddr.sin_addr.s_addr=inet_addr("136.199.54.228"); 
  bzero(&(serverAddr.sin_zero),8);

  bzero ((char *) &clientAddr, sizeof(clientAddr));
  clientAddr.sin_family=AF_INET;
  clientAddr.sin_addr.s_addr=htonl(INADDR_ANY);
  clientAddr.sin_port=htons(0);
  
  if(bind(aSocket,(struct sockaddr *) &clientAddr, sizeof(clientAddr))<0){
    printf("Fehler beim Bind\n");
    exit(-1);
  }
  /* Nachricht verschicken */
  bytesSent=sendto (aSocket,&message,strlen(message),0, (struct sockaddr *) &serverAddr, sizeof(serverAddr));
  
  bzero(message,messageLen);
  
  /* Nachricht empfangen */
  bytesReceived=recvfrom(aSocket,&message,messageLen,0,(struct sockaddr *) &clientAddr,&messageLen);
 
  printf("empfange: %s",message);
  close(aSocket);
}
