/* Einfacher TCP-basierter Echo-Server: empfange Nachricht, gib sie aus
   und schicke sie an Client zurueck
   (c) 1999 C. Hutter <hutter@uni-trier.de> */

#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <netinet/in.h>
#include <stdio.h>

int main(void)
{
  int listenSocket,acceptSocket;
  int listenPort=5000;
  struct sockaddr_in serverAddr,clientAddr;
  int clientAddrSize;
  char message[1000];
  int messageLen,bytesReceived,bytesSent;
  
  messageLen=sizeof(message);
  
  /* Socket generieren */
  listenSocket=socket(AF_INET,SOCK_STREAM,0);
  if (listenSocket<0){
    printf("Fehler bei Socketgenerierung\n");
    exit(-1);
  }
  
  /* Struct fuellen */
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(listenPort);
  serverAddr.sin_addr.s_addr=inet_addr("136.199.54.228"); /*anpassen*/
  bzero(&(serverAddr.sin_zero),8);
  
  if(bind(listenSocket,(struct sockaddr *)&serverAddr,sizeof(struct sockaddr))<0){
    printf("Fehler bei Bind\n");
    exit(-1);
  }
  
  listen(listenSocket,1);
  
  for(;;)
    {
      /* warten auf Nachrichten  */
      acceptSocket=accept(listenSocket,(struct sockaddr_in*)&clientAddr,&clientAddrSize);
      bzero(message,messageLen);
      /* empfange Nachricht */
      bytesReceived=recv(acceptSocket,message,messageLen,0);
      printf("%s",message);
      fflush(stdout);
      sleep(5);
      /* sende Nachricht zurueck */
      bytesSent=send(acceptSocket,message,bytesReceived,0);
      close(acceptSocket);
    }
}
