/* Client fuer TCP-basierten Echo-Server
   (c) 1999 C. Hutter <hutter@uni-trier.de> */

#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>

int main(void)
{
  int aSocket;
  int listenPort=5000;
  struct sockaddr_in serverAddr;
  char message[1000];
  char sendit[1000]="A line of text\n";
  int messageLen,bytesReceived,bytesSent;
  
  messageLen=sizeof(message);
  
  /* Socket generieren */  
  aSocket=socket(AF_INET,SOCK_STREAM,0);
  if(aSocket<0){
    printf("Fehler bei Socketgenerierung\n");
    exit(-1);
  }
  
  /* struct fuellen */
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(listenPort);
  serverAddr.sin_addr.s_addr=inet_addr("136.199.54.228"); /*anpassen*/
  bzero(&(serverAddr.sin_zero),8);
 
  if(connect(aSocket,(struct sockaddr *)&serverAddr,sizeof(struct sockaddr))<0)
    {
      printf("connect failed\n");
      exit(-1);
    }
  
  /* Nachricht verschicken */
  printf("sende %s",sendit);
  bytesSent=send(aSocket,sendit,strlen(sendit),0);
  bzero(message,messageLen);
  
  /* Nachricht empfangen */
  bytesReceived=recv(aSocket,message,messageLen,0);
  printf("empfange: %s",message);
  close(aSocket);
  }
