/* ein einfacher UDP-basierter Echo-Server
   Aufgabe: empfange eine Nachricht von einem Client und schicke 
   sie an ihn zurueck 
   (c) 1999 C.Hutter <hutter@uni-trier.de> */

#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <netinet/in.h>
#include <stdio.h>

int main(void)
{
  int listenSocket;
  int listenPort=5000;
  struct sockaddr_in serverAddr,clientAddr;
  int clientAddrSize;
  char message[1000];
  int messageLen,bytesReceived,bytesSent;
  
  messageLen=sizeof(message);
  
  /* Socket generieren */
  listenSocket=socket(AF_INET,SOCK_DGRAM,0);
  if (listenSocket<0){
    printf("Fehler bei Socketgenerierung\n");
    exit(-1);
  }

  /* Struct fuellen */
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(listenPort);
  serverAddr.sin_addr.s_addr=inet_addr("136.199.54.228");
  bzero(&(serverAddr.sin_zero),8);
  
  /* bind Name "serverAddr" an Socket listenSocket */
   if(bind(listenSocket,(struct sockaddr *)&serverAddr,sizeof(serverAddr))<0){
    printf("Fehler bei Bind\n");
    exit(-1);
  }
  /* Server laeuft in Endlosschleife */
  for(;;)
    {
      bzero(message,messageLen);
    
      /* Nachricht empfangen */
      bytesReceived=recvfrom(listenSocket,&message,messageLen,0,(struct sockaddr *) &clientAddr,&clientAddrSize);
      printf("%s",message);
      fflush(stdout);
      
      /* Nachricht zurueckschicken */
      bytesSent=sendto(listenSocket,&message,sizeof(message),0,(struct sockaddr *) &clientAddr, sizeof(clientAddr));
    }
}
